"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrudPlusRoutesFactory = void 0;
const crud_util_1 = require("@crudjs/crud-util");
const crud_1 = require("@crudjs/crud/lib/crud");
const crud_2 = require("@crudjs/crud");
const common_1 = require("@nestjs/common");
const constants_1 = require("../constants");
const reflection_plus_helper_1 = require("./reflection-plus.helper");
class CrudPlusRoutesFactory extends crud_1.CrudRoutesFactory {
    setSwaggerResponseOk(name) {
        const override = crud_1.R.getOverrideRoute(this.targetProto[name]);
        if (!override || !crud_1.Swagger.getResponseOk(this.targetProto[name])[common_1.HttpStatus.OK]) {
            super.setSwaggerResponseOk(name);
        }
    }
    setSwaggerOperation(name) {
        const override = crud_1.R.getOverrideRoute(this.targetProto[name]);
        if (!override) {
            super.setSwaggerOperation(name);
        }
        else {
            const summary = crud_1.Swagger.operationsMap(this.modelName)[name];
            const operationId = name + this.targetProto.constructor.name + this.modelName;
            const newOperation = crud_1.Swagger.getOperation(this.targetProto[name]);
            if (newOperation.summary === '')
                delete newOperation.summary;
            crud_1.Swagger.setOperation(Object.assign({ summary, operationId }, newOperation), this.targetProto[name]);
        }
    }
    getManyBase(name) {
        this.overrideRouteFunc(name);
    }
    getOneBase(name) {
        this.overrideRouteFunc(name);
    }
    createOneBase(name) {
        this.overrideRouteFunc(name);
    }
    createManyBase(name) {
        this.overrideRouteFunc(name);
    }
    updateOneBase(name) {
        this.overrideRouteFunc(name);
    }
    replaceOneBase(name) {
        this.overrideRouteFunc(name);
    }
    deleteOneBase(name) {
        this.overrideRouteFunc(name);
    }
    recoverOneBase(name) {
        this.overrideRouteFunc(name);
    }
    overrideRouteFunc(name) {
        if (!this.targetProto[name]) {
            super[name](name);
        }
        else {
            this.overridePlus(name);
        }
    }
    overridePlus(name) {
        this.targetProto[name] = this.targetProto[name];
        (0, crud_2.Override)(name)(this.targetProto, name, undefined);
        const isBase = reflection_plus_helper_1.R2.getIsBaseMethod(this.targetProto[name]);
        if (isBase)
            return;
        const baseMethodData = reflection_plus_helper_1.R2.getPlusBaseMetadata(this.target)[name];
        if (baseMethodData) {
            const noMergeKeys = baseMethodData[constants_1.NO_MERGE_BASE_MD] || [];
            (0, crud_util_1.objKeys)(baseMethodData).forEach((key) => {
                if (key == constants_1.NO_MERGE_BASE_MD)
                    return;
                const dataBase = baseMethodData[key];
                const dataNow = crud_1.R.get(key, this.targetProto[name]);
                if ((0, crud_util_1.isNil)(dataNow)) {
                    crud_1.R.set(key, dataBase, this.targetProto[name]);
                }
                else if (!(0, crud_util_1.isObject)(dataBase) ||
                    !(0, crud_util_1.isObject)(dataNow) ||
                    (noMergeKeys === null || noMergeKeys === void 0 ? void 0 : noMergeKeys.includes(key))) {
                    crud_1.R.set(key, dataNow, this.targetProto[name]);
                }
                else {
                    crud_1.R.set(key, Object.assign(Object.assign({}, dataBase), dataNow), this.targetProto[name]);
                }
            });
        }
    }
}
exports.CrudPlusRoutesFactory = CrudPlusRoutesFactory;
//# sourceMappingURL=crud-plus-routes.factory.js.map