"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrudPlusBase = void 0;
const crud_util_1 = require("@crudjs/crud-util");
const core_1 = require("../core");
function CrudPlusBase() {
    return (target) => {
        const methods = target.prototype;
        const metadatas = {};
        (0, crud_util_1.getOwnPropNames)(methods).forEach((prop) => {
            const metadataKeys = Reflect.getMetadataKeys(methods[prop]);
            if (metadataKeys.length) {
                metadatas[prop] = {};
                metadataKeys.forEach((metaKey) => {
                    metadatas[prop][metaKey] = Reflect.getMetadata(metaKey, methods[prop]);
                    core_1.R2.setBaseMethodMarker(methods[prop]);
                });
            }
        });
        core_1.R2.setPlusBase(metadatas, target);
    };
}
exports.CrudPlusBase = CrudPlusBase;
//# sourceMappingURL=curd-plus-base.decorator.js.map