"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotMergeBase = void 0;
const core_1 = require("../core");
function NotMergeBase(...decorators) {
    return (target, propertyKey, descriptor) => {
        const func = target[propertyKey];
        const oldKeys = new Set(Reflect.getMetadataKeys(func));
        for (const decorator of decorators) {
            decorator(target, propertyKey, descriptor);
        }
        const addedKeys = new Set(Reflect.getMetadataKeys(func).filter((i) => !oldKeys.has(i)));
        core_1.R2.setNoMergeBase(Array.from(addedKeys), func);
    };
}
exports.NotMergeBase = NotMergeBase;
//# sourceMappingURL=not-merge-base.decorator.js.map