import { CreateManyDto, CrudRequest, GetManyDefaultResponse } from "@crudjs/crud/interfaces";
import { CrudService } from "@crudjs/crud/services";
export interface CrudControllerProps<T> {
    service: CrudService<T>;
}
export interface CurdControllerMethods<T> {
    getManyBase: {
        getManyBase(req: CrudRequest): Promise<GetManyDefaultResponse<T> | T[]>;
    };
    getOneBase: {
        getOneBase(req: CrudRequest): Promise<T>;
    };
    createOneBase: {
        createOneBase(req: CrudRequest, dto: T): Promise<T>;
    };
    createManyBase: {
        createManyBase(req: CrudRequest, dto: CreateManyDto<T>): Promise<T[]>;
    };
    updateOneBase: {
        updateOneBase(req: CrudRequest, dto: Partial<T>): Promise<T>;
    };
    replaceOneBase: {
        replaceOneBase(req: CrudRequest, dto: T): Promise<T>;
    };
    deleteOneBase: {
        deleteOneBase(req: CrudRequest): Promise<void | T>;
    };
    recoverOneBase: {
        recoverOneBase(req: CrudRequest): Promise<void | T>;
    };
}
