import { CrudService } from "@crudjs/crud/services";
import { CrudControllerProps, CurdControllerMethods } from "../interfaces/crud-controller.interface";
import { PlusRouteName } from "./plus-route-name.type";
import { TupleToUnion } from "./tuple-to-union.type";
declare type mergeController<T, ExcludeMethods extends PlusRouteName[], Method extends keyof CurdControllerMethods<T>> = Method extends TupleToUnion<ExcludeMethods> ? unknown : CurdControllerMethods<T>[Method];
export declare type getController<T, ExcludeMethods extends PlusRouteName[]> = CrudControllerProps<T> & mergeController<T, ExcludeMethods, 'createManyBase'> & mergeController<T, ExcludeMethods, 'createOneBase'> & mergeController<T, ExcludeMethods, 'deleteOneBase'> & mergeController<T, ExcludeMethods, 'getManyBase'> & mergeController<T, ExcludeMethods, 'getOneBase'> & mergeController<T, ExcludeMethods, 'recoverOneBase'> & mergeController<T, ExcludeMethods, 'replaceOneBase'> & mergeController<T, ExcludeMethods, 'updateOneBase'>;
export declare type CurdControllerCtor<Entity, ExcludeFn extends PlusRouteName[] = []> = new (service: CrudService<Entity>) => getController<Entity, ExcludeFn>;
export declare type CurdPlusController<T> = getController<T, never>;
export {};
